#!/bin/bash
set -euxo pipefail

# Run tests for the bls48581 package. Takes care of linking the native BLS48581 library. 
# Assumes that the BLS48581 library has been built by running the generate.sh script in the same directory.

ROOT_DIR="${ROOT_DIR:-$( cd "$(dirname "$(realpath "$( dirname "${BASH_SOURCE[0]}" )")")" >/dev/null 2>&1 && pwd )}"

NODE_DIR="$ROOT_DIR/bls48581"
BINARIES_DIR="$ROOT_DIR/target/release"

# Link the native BLS48581 library and execute tests
pushd "$NODE_DIR" > /dev/null
	CGO_LDFLAGS="-L$BINARIES_DIR -lbls48581 -ldl" \
	CGO_ENABLED=1 \
	GOEXPERIMENT=arenas \
  go test "$@"
